#ifndef __SPI_HPP__
#define __SPI_HPP__


#include "stm32f10x_conf.h"
#include "Serial.hpp"

#define SPI_DEFAULT_SPEED 1000000

#define SPI_BUFFER_LENGTH 50

class SPI{

private:
	static bool isInit;
	static uint32_t spiSpeed;
	static uint8_t txbuffer[SPI_BUFFER_LENGTH];
	static uint8_t rxbuffer[SPI_BUFFER_LENGTH];
	static uint8_t txBufferIndex;
	static uint8_t rxBufferIndex;
	static uint8_t txremainData;
	static uint8_t rxremainData;
	static uint8_t spiBusyFlag;

	uint8_t ce_pin;
	uint8_t cs_pin;
	GPIO_TypeDef* port;

	static SPI_TypeDef* SPIx;

public:
	SPI(uint8_t fce_pin, uint8_t fcs_pin , GPIO_TypeDef* fport, uint32_t fspiSpeed = SPI_DEFAULT_SPEED);

	static void init(void);

	void readByte(uint8_t slaveNr);
	void readBytes(uint8_t slaveNr, uint8_t* data, uint8_t length);


	void writeByte(uint8_t slaveNr);
	void writeBytes(uint8_t slaveNr, uint8_t* data, uint8_t length);

};

#endif
