#ifndef SERIAL_H
#define SERIAL_H


#include "stm32f10x_conf.h"
#include "debugSerial.hpp"
#include <stdio.h>
#include <stdlib.h>




class Serial{

public:
	static void sendChar(uint8_t c);
	static void begin(uint32_t _baud = 256000);
	static uint32_t printVal(int32_t _val, int8_t radix = 10);
	static uint32_t printVal(const char name[] , int32_t _val, int8_t radix = 10);
	static void printlnVal(const char name[] ,volatile int32_t _val, int8_t radix = 10);
	static void printlnValArray(const char name[] ,volatile uint32_t* _val, uint32_t len, int8_t radix = 10);
	static void printlnValArray(const char name[] ,volatile int32_t* _val, uint32_t len, int8_t radix = 10);
	static void printlnValArray(const char name[] ,volatile uint16_t* _val, uint32_t len, int8_t radix = 10);
	static void printlnValArray(const char name[] ,volatile uint8_t* _val, uint32_t len, int8_t radix = 10);
	static uint32_t print(const char c[]);
	static uint32_t print(const char c[],uint8_t len);

	static void print(int8_t val, uint8_t radix = 10);
	static void print(uint8_t val, uint8_t radix = 10);
	static void print(int16_t val, uint8_t radix = 10);
	static void print(uint16_t val, uint8_t radix = 10);
	static void print(int val);
	static void print(double number, uint8_t digits = 3);
	static size_t printFloat(double number, uint8_t digits = 3);

	///static void print(double val);

	static void println(const char c[]);
	static void println( uint8_t val, uint8_t radix = 10);
	static void println(int8_t val);
	static void println(int val);
	static void println(uint16_t val);
	static void println(double number, uint8_t digits = 3);

	static void endl(uint8_t n = 1);
	static void tab(void);
	static void addtabs(uint32_t n);
	static uint32_t findEnd(char* ptr);
	static void addNULL(void);
	static void printDebugVal(uint8_t radix = 10);

	 template<typename T>
	 static void print(T x);
	 template<typename T>
	 static void print(T x, uint8_t radix);
	 template<typename T>
	 static void println(T x, uint8_t radix);
	 template<typename T>
	 static void println(T x);


private:

	static void addValToString(int32_t _val, int8_t radix = 10);
	static uint32_t sendBuffer(void);

	//wie ist sichergestellt, dass ich auch mehr als nur "\0" in das array passt?
	static char sendBuf[50];
	static char recBuf[50];
	static uint8_t send_iterator;
	static uint8_t rec_iterator;
};



extern Serial serial;
#endif
