#ifndef I2C_h
#define I2C_H

#ifdef __cplusplus
 extern "C" {
#endif


#include "stm32f10x_conf.h"

 //debug
//Auskommentieren wenn ISR mal stabil luft
#define I2C_ISR_DUBUG
//#define I2C_ISR_COUNT

#ifdef I2C_ISR_DUBUG
	#define I2C_ISR_COUNT
#endif


#define BUFFER_LENGTH 32






void i2c_handleEventInterrupt(void);
void i2c_handleEventInterrupt_ReadMethod1(void);
void i2c_handleEventInterrupt_ReadMethod2(void);
void i2c_handleEventInterrupt_ReadMethod3(void);
void i2c_handleErrorInterrupt(void);

void i2c_create(I2C_TypeDef * I2Cx);
void i2c_writeByte(uint8_t address, uint8_t byte);
void i2c_writeTwoBytes(uint8_t address, uint8_t byte1, uint8_t byte0);
void i2c_readTwoBytes(uint8_t address);





#ifdef __cplusplus
}
#endif

 extern I2C_TypeDef * I2C_Module;

extern volatile uint32_t i2c1_EV_ISR_Count;

 extern volatile uint8_t deviceAddress;
 extern volatile uint8_t regAddr;
 //volatile uint8_t regAddrToSend = 0;
 extern volatile uint8_t i2cDirectionWrite;
 extern volatile uint8_t i2cBusyFlag;
 //volatile uint8_t i2cReadDev = 0;

 //---------------------------
 // receive
 extern volatile uint8_t rxBuffer[BUFFER_LENGTH];
 extern volatile int16_t rxBufferIndex;
 extern volatile int16_t rxRemainCount;
 //volatile uint8_t rxLastPull = 0;
 //---------------------------


 //---------------------------
 // transmit
 extern volatile uint8_t txBuffer[BUFFER_LENGTH];
 extern volatile int16_t txBufferIndex;
 extern volatile int16_t txCount;
 //---------------------------

 //---------------------------
 //debug
 extern volatile uint32_t i2cDebug_EV_ISRanfang[50];
 extern volatile uint32_t i2cDebug_EV_ISRende[50];

 extern volatile uint32_t i2cDebug_EV_ISRanfang_DebugFlags[50];
 extern volatile uint32_t i2cDebug_EV_ISRende_DebugFlags[50];

 extern volatile uint8_t debugflag;
 //---------------------------



#endif
