#include "Serial.hpp"


//wie ist sichergestellt, dass ich auch mehr als nur "\0" in das array passt?
char Serial::sendBuf[50] = {""};
char Serial::recBuf[50] = {""};
uint8_t Serial::send_iterator = 0;
uint8_t Serial::rec_iterator = 0;

void Serial::sendChar(uint8_t c){

	while(USART_GetFlagStatus(USART1, USART_FLAG_TXE)== RESET){};
	USART_SendData(USART1, c);

}
 void Serial::begin(uint32_t _baud){

	 /* USART configuration structure for USART1 */
	    USART_InitTypeDef usart1_init_struct;
	    /* Bit configuration structure for GPIOA PIN9 and PIN10 */
	    GPIO_InitTypeDef gpioa_init_struct;

	    /* Enalbe clock for USART1, AFIO and GPIOA */
	    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_AFIO |
	                           RCC_APB2Periph_GPIOA, ENABLE);

	    /* GPIOA PIN9 alternative function Tx */
	    gpioa_init_struct.GPIO_Pin = GPIO_Pin_9;
	    gpioa_init_struct.GPIO_Speed = GPIO_Speed_50MHz;
	    gpioa_init_struct.GPIO_Mode = GPIO_Mode_AF_PP;
	    GPIO_Init(GPIOA, &gpioa_init_struct);
	    /* GPIOA PIN9 alternative function Rx */
	    gpioa_init_struct.GPIO_Pin = GPIO_Pin_10;
	    gpioa_init_struct.GPIO_Speed = GPIO_Speed_50MHz;
	    gpioa_init_struct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	    GPIO_Init(GPIOA, &gpioa_init_struct);

	    /* Enable USART1 */
	    USART_Cmd(USART1, ENABLE);
	    /* Baud rate 9600, 8-bit data, One stop bit
	     * No parity, Do both Rx and Tx, No HW flow control
	     */
	    usart1_init_struct.USART_BaudRate = _baud;
	    usart1_init_struct.USART_WordLength = USART_WordLength_8b;
	    usart1_init_struct.USART_StopBits = USART_StopBits_1;
	    usart1_init_struct.USART_Parity = USART_Parity_No ;
	    usart1_init_struct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	    usart1_init_struct.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	    /* Configure USART1 */
	    USART_Init(USART1, &usart1_init_struct);
	    /* Enable RXNE interrupt */
	 //  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
	    /* Enable USART1 global interrupt */
	  // f NVIC_EnableIRQ(USART1_IRQn);
 }
 uint32_t Serial::printVal(int32_t _val, int8_t radix){
	 addValToString(_val, radix);
	 return sendBuffer();
 }
 uint32_t Serial::printVal(const char name[] , int32_t _val, int8_t radix){
	 uint32_t a = 0;
		 while(name[a]!= '\0'){
			 sendChar( name[a++]);
		 }
		 sendChar( ':');
		 tab();
		 addValToString(_val, radix);
		  a += 1 + sendBuffer();
		  return a;
 }
 void Serial::printlnVal(const char name[] ,volatile int32_t _val, int8_t radix){

	 uint32_t a = 0;
 		 while(name[a]!= '\0'){
 			 sendChar( name[a++]);
 		 }
 		 sendChar( ':');
 		addtabs(a);
 		 addValToString(_val, radix);
 		 if(radix == 2){
 			 addNULL();
 		 }

 		 sendBuffer();
 		 endl();
  }
 void Serial::printlnValArray(const char name[] , volatile uint32_t* _val, uint32_t len, int8_t radix){
	for(uint32_t b= 0; b < len; b++){
		uint32_t a = 0;
		 while(name[a]!= '\0'){
			 sendChar( name[a++]);
		 }
		sendChar( '[');
		a += printVal(b);
		sendChar( ']');
		 sendChar( ':');
		 addtabs(a+3);
		 addValToString(_val[b], radix);
		 if(radix == 2){
		 			 addNULL();
		 		 }
		 sendBuffer();
		 endl();
	}
 }
 void Serial::printlnValArray(const char name[] , volatile int32_t* _val, uint32_t len, int8_t radix){
 	for(uint32_t b= 0; b < len; b++){
 		uint32_t a = 0;
 		 while(name[a]!= '\0'){
 			 sendChar( name[a++]);
 		 }
 		sendChar( '[');
 				a += printVal(b);
 				sendChar( ']');
 				 sendChar( ':');
 				 addtabs(a+3);
 				 addValToString(_val[b], radix);
 				 if(radix == 2){
 				 			 addNULL();
 				 		 }
 				 sendBuffer();
 				 endl();
 	}
  }
 void Serial::printlnValArray(const char name[] ,volatile uint16_t* _val, uint32_t len, int8_t radix){
	 for(uint32_t b= 0; b < len; b++){
	  		uint32_t a = 0;
	  		 while(name[a]!= '\0'){
	  			 sendChar( name[a++]);
	  		 }
	  		sendChar( '[');
	  				a += printVal(b);
	  				sendChar( ']');
	  				 sendChar( ':');
	  				 addtabs(a+3);
	  				 addValToString(_val[b], radix);
	  				 if(radix == 2){
	  				 			 addNULL();
	  				 		 }
	  				 sendBuffer();
	  				 endl();
	  	}
 }
void Serial::printlnValArray(const char name[] ,volatile uint8_t* _val, uint32_t len, int8_t radix){
	for(uint32_t b= 0; b < len; b++){
	 		uint32_t characterCount = 0;
	 		 while(name[characterCount]!= '\0'){
	 			 sendChar( name[characterCount++]);
	 		 }
	 		sendChar( '[');
	 		characterCount += printVal(b);
	 				sendChar( ']');
	 				 sendChar( ':');
	 				 addtabs(characterCount+3);
	 				 addValToString(_val[b], radix);
	 				 if(radix == 2){
	 				 			 addNULL();
	 				 		 }
	 				 sendBuffer();
	 				 endl();
	 	}
}

 void Serial::addValToString(int32_t _val, int8_t radix){
	 itoa(_val, sendBuf,radix);
 }

uint32_t Serial::sendBuffer(void){
	 uint32_t a = 0;
	 while(sendBuf[a] != '\0'){
		 sendChar(sendBuf[a++]);
	 }
	 return a;
 }
 uint32_t Serial::print(const char c[]){
	 uint8_t a = 0;
	 	 while(c[a] != '\0'){
	 		 sendChar(c[a++]);
	 	 }
	 	 return a;
 }
 uint32_t Serial::print(const char c[],uint8_t len){
 	 uint8_t a = 0;
 	 	 while(c[a] != '\0' && a < len){
 	 		 sendChar(c[a++]);
 	 	 }
 	 	 return a;
  }
 void Serial::print(int8_t val, uint8_t radix){
	 printVal(val, radix);
 }
 void Serial::print(uint8_t val, uint8_t radix){
	 printVal(val, radix);
 }
 void Serial::print(int16_t val, uint8_t radix){
	 printVal(val, radix);
 }
 void Serial::print(uint16_t val, uint8_t radix){
	 printVal(val, radix);
 }

 void Serial::print(int val){
	 printVal(val, 10);
 }
 void Serial::print(double number, uint8_t digits){
	 printFloat(number, digits);
 }

 size_t Serial::printFloat(double number,  uint8_t digits){


	   size_t n = 0;

	   //if (isnan(number)) return print("nan");
	  // if (isinf(number)) return print("inf");
	   if (number > 4294967040.0) return print ("ovf");  // constant determined empirically
	   if (number <-4294967040.0) return print ("ovf");  // constant determined empirically

	   // Handle negative numbers
	   if (number < 0.0)
	   {
		   sendChar('-');
	      //n += print('-');
	      number = -number;
	   }

	   // Round correctly so that print(1.999, 2) prints as "2.00"
	   double rounding = 0.5;
	   for (uint8_t i=0; i<digits; ++i)
	     rounding /= 10.0;

	   number += rounding;

	   // Extract the integer part of the number and print it
	   unsigned long int_part = (unsigned long)number;
	   double remainder = number - (double)int_part;
	  // n += print(int_part);
	   printVal(int_part);
	   // Print the decimal point, but only if there are digits beyond
	   if (digits > 0) {
	    // n += print('.');
		   sendChar('.');
	   }

	   // Extract digits from the remainder one at a time
	   while (digits-- > 0)
	   {
	     remainder *= 10.0;
	     unsigned int toPrint = (unsigned int)(remainder);
	     //n += print(toPrint);
	     printVal(toPrint);
	     remainder -= toPrint;
	   }

	   return n;
 }
 void Serial::println(const char c[]){
	 uint32_t a = 0;
	 while(c[a] != '\0'){
		 sendChar(c[a++]);
	 }
	 sendChar('\n');
	sendChar('\r');


 }
 void Serial::println( uint8_t val, uint8_t radix){
	 printVal(val, radix);
	 endl();
 }
 void Serial::println(int8_t val){
	 printVal(val, 10);
	 endl();
 }
 void Serial::println(int val){
	 printVal(val, 10);
	 endl();
 }
void Serial::println(uint16_t val){
	 printVal(val, 10);
	endl();
 }

 void Serial::endl(uint8_t n){
	 for(uint8_t a = 0; a < n; a++){
		 sendChar('\n');
		sendChar('\r');
	 }

 }
 void Serial::println(double number, uint8_t digits){
	 print(number, digits);
	 endl();
 }
 void Serial::tab(void){
	 sendChar('\t');
 }
 void Serial::addtabs(uint32_t n){
	 uint32_t a = 0;
	 if(n != 0){
		 a = 3 - ((n+1)/ 8);
	 }

	 for(uint32_t b = 0; b < a; b++){
		 sendChar('\t');
	 }
  }
 uint32_t Serial::findEnd(char* ptr){
	 uint32_t a = 0;
	 while(ptr[a] != '\0'){
		 a++;
	 }
	 return a;
 }
 void Serial::addNULL(void){
	 uint32_t a = 32 - findEnd(sendBuf);
	 for(uint32_t b = 0; b < a; b++){
		 sendChar('0');
	 }
 }
 void Serial::printDebugVal(uint8_t radix){

	 if(radix == 2)printHeader();

	 serial.printlnValArray("debug32", debug32, 20, 2);


 }



 template<typename T>
 void print(T x);

 template<typename T>
 void print(T x, uint8_t radix);

 template<typename T>
 void Serial::println(T x, uint8_t radix){
	 printVal(x, radix);
	 endl();
 }

 template<typename T>
 void Serial::println(T x){
	 printVal(x, 10);
	 endl();
 }

 Serial serial;
