#include "debugSerial.hpp"

//I2C1
void printI2C1(bool takeValFromDebugVal){
	serial.print("I2C1:");
	if(takeValFromDebugVal){
			serial.println("(token from DebugVar[...])");
		}else{
			serial.println("(now reading)");
		}
	printHeader();

	if(takeValFromDebugVal){
		serial.printlnVal("CR1", debug32[0], 2);
		serial.printlnVal("CR2", debug32[1], 2);
		serial.printlnVal("OAR1", debug32[2], 2);
		serial.printlnVal("OAR2", debug32[3], 2);
		serial.printlnVal("DR", debug32[4], 2);
		serial.printlnVal("SR1", debug32[5], 2);
		serial.printlnVal("SR2", debug32[6], 2);
		serial.printlnVal("CCR", debug32[7], 2);
		serial.printlnVal("TRISE", debug32[8], 2);
	}else{
		serial.printlnVal("CR1", I2C1->CR1, 2);
		serial.printlnVal("CR2", I2C1->CR2, 2);
		serial.printlnVal("OAR1", I2C1->OAR1, 2);
		serial.printlnVal("OAR2", I2C1->OAR2, 2);
		serial.printlnVal("DR", I2C1->DR, 2);
		serial.printlnVal("SR1", I2C1->SR1, 2);
		serial.printlnVal("SR2", I2C1->SR2, 2);
		serial.printlnVal("CCR", I2C1->CCR, 2);
		serial.printlnVal("TRISE", I2C1->TRISE, 2);
	}

}
void printRCC(bool takeValFromDebugVal){
	serial.print("RCC:");
	if(takeValFromDebugVal){
		serial.println("(token from DebugVar[...])");
	}else{
		serial.println("(now reading)");
	}
	printHeader();
	if(takeValFromDebugVal){
			serial.printlnVal("CR1", debug32[0], 2);
			serial.printlnVal("CR2", debug32[1], 2);
			serial.printlnVal("CIR", debug32[2], 2);
			serial.printlnVal("APB2RSTR", debug32[3], 2);
			serial.printlnVal("APB1RSTR", debug32[4], 2);
			serial.printlnVal("AHBENR", debug32[5], 2);
			serial.printlnVal("APB2ENR", debug32[6], 2);
			serial.printlnVal("APB1ENR", debug32[7], 2);
			serial.printlnVal("BDCR", debug32[8], 2);
			serial.printlnVal("CSR", debug32[9], 2);
		}else{
			serial.printlnVal("CR1", RCC->CR, 2);
			serial.printlnVal("CR2", RCC->CFGR, 2);
			serial.printlnVal("CIR", RCC->CIR, 2);
			serial.printlnVal("APB2RSTR", RCC->APB2RSTR, 2);
			serial.printlnVal("APB1RSTR", RCC->APB1RSTR, 2);
			serial.printlnVal("AHBENR", RCC->AHBENR, 2);
			serial.printlnVal("APB2ENR", RCC->APB2ENR, 2);
			serial.printlnVal("APB1ENR", RCC->APB1ENR, 2);
			serial.printlnVal("BDCR", RCC->BDCR, 2);
			serial.printlnVal("CSR", RCC->CSR, 2);
		}

}
void printAFIO(bool takeValFromDebugVal){
	serial.println("AFIO:");
	printHeader();
	serial.printlnVal("EVCR", AFIO->EVCR, 2);
	serial.printlnVal("MAPR", AFIO->MAPR, 2);
	serial.printlnValArray("EXTICR", &AFIO->EXTICR[0], 4, 2);

	serial.printlnVal("RESERVED0", AFIO->RESERVED0, 2);
	serial.printlnVal("MAPR2", AFIO->MAPR2, 2);

}
void printNVIC(bool takeValFromDebugVal){
	serial.println("NVIC:");
	printHeader();
	serial.printlnValArray("ISER", &NVIC->ISER[0], 8, 2);
	serial.printlnValArray("ICER", &NVIC->ICER[0], 8, 2);
	serial.printlnValArray("ISPR", &NVIC->ISPR[0], 8, 2);
	serial.printlnValArray("ICPR", &NVIC->ICPR[0], 8, 2);
	serial.printlnValArray("IABR", &NVIC->IABR[0], 8, 2);
	serial.printlnValArray("IP", &NVIC->IP[0], 24, 2);
	serial.printlnVal("STIR", NVIC->STIR, 2);

}
void printHeader(void){
	serial.print("BitNrHeader:" );
	serial.tab();
	serial.tab();
	serial.print("10987654321098765432109876543210");
	serial.endl();
	while(USART_GetFlagStatus(USART1, USART_FLAG_TXE)== RESET){};

}

void printDebugVal(){
	serial.println("debug32:");
	printHeader();
	serial.printlnValArray("debug32", debug32, 10, 2);

}

void printDebugVal_EV_ISR(){

	#ifdef I2C_ISR_COUNT
		serial.printlnVal("I2C_ISR Aufrufe gesamt", i2c1_EV_ISR_Count);
		serial.endl(2);
	#else
		serial.println("I2C1_ISR_EV_Aufrufe werden nicht getrackt");
	#endif

	#ifdef I2C_ISR_DUBUG
		for(uint8_t a = 0; a < 10; a++){
			serial.printlnVal("ISR_Aufrug Nummer", a+1);

			serial.printlnVal("ISRanfang SR1", i2cDebug_EV_ISRanfang[a*2], 2);
			serial.printlnVal("ISRanfang SR2", i2cDebug_EV_ISRanfang[(a*2) + 1], 2);
			serial.endl();
			serial.printlnVal("ISRende SR1", i2cDebug_EV_ISRende[a*2], 2);
			serial.printlnVal("ISRende SR2", i2cDebug_EV_ISRende[(a*2) + 1], 2);
			serial.endl(2);
		}
	#else
		serial.println("I2C1_ISR_EV_DebugVal werden nicht getrackt");
	#endif
}
