#include "i2c.h"

I2C_TypeDef * I2C_Module;

//volatile uint8_t dataByte1;
//volatile uint8_t dataByte0;
//volatile uint8_t receivedDataByte1;
//volatile uint8_t receivedDataByte0;


//--------------------------------------------

volatile uint8_t deviceAddress;
volatile uint8_t regAddr;
//volatile uint8_t regAddrToSend = 0;
volatile uint8_t i2cDirectionWrite = 0;
volatile uint8_t i2cBusyFlag = 0;
//volatile uint8_t i2cReadDev = 0;

//---------------------------
// receive
volatile uint8_t rxBuffer[BUFFER_LENGTH];
volatile int16_t rxBufferIndex = 0;
volatile int16_t rxRemainCount = 0;
//volatile uint8_t rxLastPull = 0;
//---------------------------


//---------------------------
// transmit
volatile uint8_t txBuffer[BUFFER_LENGTH] = {9,9,9,9,9,9,9,9,9,9,   9,9,9,9,9,9,9,9,9,9,  9,9,9,9,9,9,9,9,9,9,	9,9};
volatile int16_t txBufferIndex = 0;
volatile int16_t txCount = 0;
//---------------------------

//---------------------------
//debug
volatile uint32_t i2cDebug_EV_ISRanfang[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint32_t i2cDebug_EV_ISRende[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint32_t i2cDebug_EV_ISRanfang_DebugFlags[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint32_t i2cDebug_EV_ISRende_DebugFlags[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint8_t debugflag = 0;

volatile uint32_t i2c1_EV_ISR_Count = 0;
//---------------------------


// ISR neu

void i2c_handleEventInterrupt_ReadMethod1(void){
/*
	if(i2c1_EV_ISR_Count < 25){
		i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2) +1] = I2C_Module->SR2;
		i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2)] = I2C_Module->SR1;

		i2cDebug_EV_ISRanfang_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
	}
*/
	//const uint16_t readSR1 = I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
	if(i2cDirectionWrite){

		if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_SB) == SET){
			//SB EV
		   I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Transmitter);
		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_ADDR) == SET){
			//ADDR EV

			//Clear Flag
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);

			I2C_SendData(I2C_Module, regAddr);

			if(rxRemainCount != 0){
				i2cDirectionWrite = 0;
				I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);
				debug32[3] |= (1 << 3);
			}else if(txCount != 0){
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
			}
		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_TXE) == SET){
			if(txCount != 0){
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
			}else if(txCount == 0){
				I2C_GenerateSTOP(I2C_Module, ENABLE);
				i2cBusyFlag = 0;
			}
		}
	}else{
		//Receiver
		if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_SB) == SET){
			//clock streching!!!

			I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Receiver);
			I2C_ITConfig(I2C_Module, I2C_IT_BUF, ENABLE);

		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_BTF) == SET){
			//clock streching!!!
			//Clear BTF Flag
			I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
			I2C_ReceiveData(I2C_Module);



			I2C_GenerateSTART(I2C_Module, ENABLE);

		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_ADDR) == SET){
			//clock streching!!!
			//Clear ADDR_Flag
			//for(uint32_t a = 0; a < 50; a++);
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
			//SingleByte Read
			if(rxRemainCount == 1){

				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}

		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_RXNE) == SET){

			rxBuffer[txBufferIndex++] = I2C_ReceiveData(I2C_Module);
			--rxRemainCount;
			if(rxRemainCount == 1){
				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}else if(rxRemainCount == 0){
				i2cBusyFlag = 0;
			}
		}

	}
	//ledToggle();
	/*
	if(i2c1_EV_ISR_Count < 25){
		i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2) +1] = I2C_Module->SR2;
		i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2)] = I2C_Module->SR1;

		i2cDebug_EV_ISRende_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
	}

	++i2c1_EV_ISR_Count;
*/

}

void i2c_handleEventInterrupt_ReadMethod3(void){

	if(!i2cBusyFlag){
		//ungewschter ISR-Aufruf
		ledAn();
	}



	//Reihenfolge beachten um ADDRF nicht aus Versehen zu lschen
	const uint16_t SR2 = I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
	const uint16_t SR1 = I2C_ReadRegister(I2C_Module, I2C_Register_SR1);

#ifdef I2C_ISR_DUBUG
	if(i2c1_EV_ISR_Count < 25){
			//i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2) +1] = readSR2;
			i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2)] = SR1;

			//i2cDebug_EV_ISRanfang_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
		}
#endif
	if(!i2cDirectionWrite){
		//Receiver
		if(SR1 & I2C_FLAG_RXNE){
			// no clock streching
			rxBuffer[txBufferIndex++] = I2C_ReceiveData(I2C_Module);
			--rxRemainCount;
			if(rxRemainCount == 1){
				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}else if(rxRemainCount == 0){
				i2cBusyFlag = 0;
			}
		}else if(SR1 & I2C_FLAG_SB){

			//streching the clock

			I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Receiver);
			I2C_ITConfig(I2C_Module, I2C_IT_BUF, ENABLE);
			/*
			if(rxRemainCount == 2){
				I2C_NACKPositionConfig(I2C_Module, I2C_NACKPosition_Next);
				I2C_AcknowledgeConfig(I2C_Module, ENABLE);
			}else{
				I2C_ITConfig(I2C_Module, I2C_IT_BUF, ENABLE);
			}
			*/
		}else if(SR1 & I2C_FLAG_BTF){
			//streching the clock
			if(SR1 & I2C_FLAG_TXE){
				//Clear BTF Flag
				//I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
				I2C_ReceiveData(I2C_Module);
				I2C_GenerateSTART(I2C_Module, ENABLE);

			}

		}else if(SR1 & I2C_FLAG_ADDR){
			//streching the clock
			//Clear ADDR_Flag
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
			//SingleByte Read
			if(rxRemainCount == 1){

				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}
		}
	}else{
	//Transmitter
		if(SR1 & I2C_FLAG_SB){
			//SB EV
			//Streching the clock

		   I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Transmitter);
		}else if(SR1 & I2C_FLAG_ADDR){
			//ADDR EV
			//Streching the clock

			//Clear Flag
			//I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);

			I2C_SendData(I2C_Module, regAddr);

			if(rxRemainCount != 0){
				i2cDirectionWrite = 0;
				I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
			}else if(txCount != 0){
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
				if(txCount == 0){
					I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
				}
			}
		}else if(SR1 & I2C_FLAG_BTF){
			if(txCount == 0){
				I2C_ReceiveData(I2C_Module);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
				i2cBusyFlag = 0;
				//I2C_ITConfig(I2C_Module, I2C_IT_BUF, ENABLE);
			}else{
				if(txCount != 0){
					txCount--;
					I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
					if(txCount == 0){
						I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
					}
				}
			}
		}else if(SR1 & I2C_FLAG_TXE){
			if(txCount != 0){
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
				if(txCount == 0){
					I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
				}
			}
		}

	}
	//ledToggle();
#ifdef I2C_ISR_DUBUG
	if(i2c1_EV_ISR_Count < 25){
		//i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2) +1] = I2C_Module->SR2;
		i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2)] = I2C_Module->SR1;

		//i2cDebug_EV_ISRende_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
	}

#endif
#ifdef I2C_ISR_COUNT
	++i2c1_EV_ISR_Count;
#endif

}

// ISR neu

void i2c_handleEventInterrupt_ReadMethod2(void){



	//Reihenfolge beachten um ADDRF nicht aus Versehen zu lschen
	const uint16_t readSR2 = I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
	const uint16_t readSR1 = I2C_ReadRegister(I2C_Module, I2C_Register_SR1);

#ifdef I2C_ISR_DUBUG
	if(i2c1_EV_ISR_Count < 25){
			i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2) +1] = readSR2;
			i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2)] = readSR1;

			i2cDebug_EV_ISRanfang_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
		}
#endif
	if(i2cDirectionWrite){

		if(readSR1 & I2C_FLAG_SB){
			//SB EV
			//Streching the clock

		   I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Transmitter);
		}else if(readSR1 & I2C_FLAG_ADDR){
			//ADDR EV
			//Streching the clock

			//Clear Flag
			//I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);



			I2C_SendData(I2C_Module, regAddr);

			if(rxRemainCount != 0){
				i2cDirectionWrite = 0;
				I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
			}else if(txCount != 0){
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
				if(txCount == 0){
					I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
				}
			}
		}else if(readSR1 & I2C_FLAG_BTF){
			if(txCount == 0){
				I2C_GenerateSTOP(I2C_Module, ENABLE);
				i2cBusyFlag = 0;
			}else{
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
				if(txCount == 0){
					I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
				}
			}
		}else if(readSR1 & I2C_FLAG_TXE){
			if(txCount != 0){
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
				if(txCount == 0){
					I2C_ITConfig(I2C_Module, I2C_IT_BUF, DISABLE);//TxE und RxNE Sperren... auf BTF warten
				}
			}

			/*else if(txCount == 0){
				I2C_GenerateSTOP(I2C_Module, ENABLE);
				i2cBusyFlag = 0;
			}*/
		}
	}else{
		//Receiver
		if(readSR1 & I2C_FLAG_SB){

			//streching the clock

			I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Receiver);

			if(rxRemainCount == 2){
				I2C_NACKPositionConfig(I2C_Module, I2C_NACKPosition_Next);
				I2C_AcknowledgeConfig(I2C_Module, ENABLE);
			}else{
				I2C_ITConfig(I2C_Module, I2C_IT_BUF, ENABLE);
			}

		}else if(readSR1 & I2C_FLAG_BTF){
			//streching the clock
			if(readSR1 & I2C_FLAG_TXE){
				//Clear BTF Flag
				I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
				I2C_ReceiveData(I2C_Module);
				I2C_GenerateSTART(I2C_Module, ENABLE);

			}else if(readSR1 & I2C_FLAG_RXNE){
				if(rxRemainCount == 2){
					I2C_GenerateSTOP(I2C_Module, ENABLE);
					rxBuffer[txBufferIndex++] = I2C_ReceiveData(I2C_Module);
					--rxRemainCount;
				}
				rxBuffer[txBufferIndex++] = I2C_ReceiveData(I2C_Module);
				--rxRemainCount;
			}

		}else if(readSR1 & I2C_FLAG_ADDR){
			//streching the clock
			//Clear ADDR_Flag
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
			//SingleByte Read
			if(rxRemainCount == 1){

				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}else if(rxRemainCount == 2){
				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
			}

		}else if(readSR1 & I2C_FLAG_RXNE){
			// no clock streching
			rxBuffer[txBufferIndex++] = I2C_ReceiveData(I2C_Module);
			--rxRemainCount;
			if(rxRemainCount == 1){
				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}else if(rxRemainCount == 0){
				i2cBusyFlag = 0;
			}
		}

	}
	//ledToggle();
#ifdef I2C_ISR_DUBUG
	if(i2c1_EV_ISR_Count < 25){
		//i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2) +1] = I2C_Module->SR2;
		i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2)] = I2C_Module->SR1;

		//i2cDebug_EV_ISRende_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
	}
#endif
#ifdef I2C_ISR_COUNT
	++i2c1_EV_ISR_Count;
#endif

}
// ISR
void i2c_handleErrorInterrupt(void){
	static uint32_t i2c_ER_ISR_Count;
	//ledAn();
	if(i2c_ER_ISR_Count++ == 0){
		debug32[5] = I2C_Module->SR2;
		debug32[4] = I2C_Module->SR1;

	}


	I2C_ClearFlag(I2C_Module, I2C_FLAG_AF);
	I2C_ClearFlag(I2C_Module, I2C_FLAG_ARLO);
	I2C_ClearFlag(I2C_Module, I2C_FLAG_BERR);

	I2C_GenerateSTOP(I2C_Module, ENABLE);
	i2cBusyFlag = 0;
}
